% DEFORMED = deform2D(IM,FIELD,mode) 
% Applies a deformation field
% IM: image to deform, of size M x N
% field: field to apply, of size I x J x 2
% mode: can be any of the model from interp2: 'nearest', 'linear', 'spline', or 'cubic'
% DEFORMED: the output, of size I x J
function DEF = deform2D(IM,FIELD,mode)

if nargin<3
    mode='linear';
end

Dx=FIELD(:,:,1);
Dy=FIELD(:,:,2);

DEF=zeros(size(FIELD,1),size(FIELD,2));
[XX,YY]=ndgrid(1:size(FIELD,1),1:size(FIELD,2));
XXd=XX+Dx;
YYd=YY+Dy;
DEF(:)=interp2(double(IM),YYd(:),XXd(:),mode,0);

    

